#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#TEMPLATE(PrintBandEquates,'Print Band Equates'),FAMILY('CW20','ABC')
#EXTENSION(StmtPrintBandEquates,'Statements Print Band Equates'),PROCEDURE
#!--------------------------------------------------------------------
#! Copyright  1998-2002 by Roberto Artigas Jr.
#! All rights reserved world wide.
#! Contact e-mail: rartiga1@midsouth.rr.com
#!--------------------------------------------------------------------
#RESTRICT,WHERE(%Window AND %ProcedureTemplate = 'Report')
#ENDRESTRICT
#!--------------------------------------------------------------------
#SHEET
 #TAB('&Usage')
  #BOXED('')
   #DISPLAY('This template builds height equates for all report bands.')
   #DISPLAY('')
   #DISPLAY('This is used when creating multi-detail-band conditional')
   #DISPLAY('print reports. It checks the horizontal alignment of the')
   #DISPLAY('control''s height within a band and reports errors when')
   #DISPLAY('the control''s bottom is lower than the band''s bottom.')
   #DISPLAY('')
   #DISPLAY('The control being bigger that the band is a problem if')
   #DISPLAY('you are using the band''s height to 1) calculate your')
   #DISPLAY('position on the report, 2) calculate if you have enough')
   #DISPLAY('space to print the next detail line (or group of lines),')
   #DISPLAY('and 3) calculate when to print a set of custom footers.')
   #DISPLAY('')
   #DISPLAY('If it finds a detail control inside the band that is')
   #DISPLAY('longer that the band, it will adjust the band''s height.')
   #DISPLAY('')
   #DISPLAY('Remember it is very hard to spot bad alignment when')
   #DISPLAY('the bad alignment is less than 50/1000''s of an inch.')
  #ENDBOXED
 #ENDTAB
 #TAB('&Options')
  #BOXED('Field Heights')
   #PROMPT('Show heights of all fields?',CHECK),%AllHeights,DEFAULT(0),AT(10)
   #DISPLAY('')
   #DISPLAY('Turning this option ON will show you all the controls and')
   #DISPLAY('their heights inside the detail band. This will allow you')
   #DISPLAY('to visually inspect for any errors when controls inside')
   #DISPLAY('the band are larger than the band.')
   #DISPLAY('')
   #DISPLAY('Turning this option OFF will show you only actual band')
   #DISPLAY('equates and their actual/calculated heights.')
   #DISPLAY('')
   #DISPLAY('Turning this ON/OFF does not make any difference in')
   #DISPLAY('the automatic correction if the band''s height if a control')
   #DISPLAY('is bigger than the band it is in. While this might produce')
   #DISPLAY('report detail areas that are shorter than normal, it sure')
   #DISPLAY('beats having unexpected page overflows.')
   #DISPLAY('')
   #DISPLAY('Having a customer call you because you got a nasty')
   #DISPLAY('page overflow, or something is not lined up correctly')
   #DISPLAY('is not what you want. It will not make you happy.')
  #ENDBOXED
 #ENDTAB
 #TAB('&Reports')
  #BOXED('Report Layout Used')
   #DISPLAY('There is a 1/2 inch margin on all four borders. This is')
   #DISPLAY('exactly 500/1000''s of an inch. This allows for 3 hole')
   #DISPLAY('and 2 hole punches to be able to work on a standard')
   #DISPLAY('8-1/2" x 11" (8500 x 11000 thousand''s) sheet of paper')
   #DISPLAY('without disturbing the body of the report.')
   #DISPLAY('')
   #DISPLAY('There is a 52/1000''s of an inch (smallest I could get)')
   #DISPLAY('header and footer (might not be needed) in the report.')
   #DISPLAY('')
   #DISPLAY('This gives an area of 9896 out of 11000 where to print.')
   #DISPLAY('')
   #DISPLAY('All bands MUST HAVE a use variable. PUT ONE IN!')
   #DISPLAY('All bands MUST HAVE a use variable. PUT ONE IN!')
   #DISPLAY('All bands MUST HAVE a use variable. PUT ONE IN!')
   #DISPLAY('')
   #DISPLAY('I hang around the newsgroups quite a bit, so if you')
   #DISPLAY('have questions post them in the #template newsgroup.')
   #DISPLAY('')
   #DISPLAY('Roberto Artigas Jr')
  #ENDBOXED
 #ENDTAB
#ENDSHEET
#!--------------------------------------------------------------------
#AT(%DataSection),LAST
#EQUATE(%rptWidth,EXTRACT(%ReportStatement,'AT',3))
#EQUATE(%rptHeight,EXTRACT(%ReportStatement,'AT',4))
#EQUATE(%rptArea,EXTRACT(%ReportStatement,'AT',4))
#!
#EQUATE (%MarginVert,1000)          #! Margin on (Top + Bottom)
#EQUATE (%HeadAndFoot,0)            #! Add (Header + Footer)
#EQUATE (%AtUse,'')
#EQUATE (%AtUse3,'')
#EQUATE (%AtLabel,'')
#EQUATE (%AtBand,'')
#EQUATE (%LengthError,'')
#DECLARE(%AtLocX,LONG)
#DECLARE(%AtLocY,LONG)
#DECLARE(%AtLocW,LONG)
#DECLARE(%AtLocH,LONG)
#!
#EQUATE (%OldUse,'')
#EQUATE (%OldType,'')
#EQUATE (%OldControl,'')
#DECLARE(%OldLocX,LONG)
#DECLARE(%OldLocY,LONG)
#DECLARE(%OldLocW,LONG)
#DECLARE(%OldLocH,LONG)
#!
#DECLARE(%HeaderX,LONG)
#DECLARE(%HeaderH,LONG)
#DECLARE(%FooterX,LONG)
#DECLARE(%FooterH,LONG)
#DECLARE(%FormX,LONG)
#DECLARE(%FormH,LONG)
#!
!BOE: DataSection(LAST)
#FOR(%ReportControl)
 #SET(%AtUse,EXTRACT(%ReportControlStatement,'USE',1))
 #SET(%AtUse3,EXTRACT(%ReportControlStatement,'USE',3))
 #IF(%AtUse='')
  #SET(%AtUse,%ReportControl)
 #ENDIF
#! ReportControl = '%ReportControl'
#! AtUse         = '%AtUse'
#! AtUse3        = '%AtUse3'
 #IF(%AtUse3)
  #SET(%AtUse,%AtUse3)
 #ENDIF
 #SET(%AtLabel,%AtUse)
 #IF(SUB(%AtUse,1,1)='?')
  #SET(%AtLabel,SUB(%AtUse,2,LEN(%AtUse)-1))
 #ENDIF
 #SET(%AtLocX,EXTRACT(%ReportControlStatement,'AT',1))
 #SET(%AtLocY,EXTRACT(%ReportControlStatement,'AT',2))
 #SET(%AtLocW,EXTRACT(%ReportControlStatement,'AT',3))
 #SET(%AtLocH,EXTRACT(%ReportControlStatement,'AT',4))
#!
 #CASE(%ReportControlType)
 #OF('HEADER')
  #IF(%OldUse)
%[23]OldUse EQUATE(%OldLocH) #<! %[15]OldType %OldControl
  #ENDIF
  #SET(%HeaderX,%AtLocX)
  #SET(%HeaderH,%AtLocH)
  #SET(%AtLabel,'BAND:' & %AtLabel)
  #IF(%AllHeights)
!
! %[23]AtLabel %[15]ReportControlType %ReportControl
!
  #ENDIF
#!%[23]AtLabel EQUATE(%AtLocH) #<! %[15]ReportControlType %ReportControl
  #SET(%HeadAndFoot,%HeadAndFoot+%HeaderH)
  #SET(%OldType,%ReportControlType)
  #SET(%OldControl,%ReportControl)
  #SET(%OldUse,%AtLabel)
  #SET(%OldLocX,%AtLocX)
  #SET(%OldLocY,%AtLocY)
  #SET(%OldLocW,%AtLocW)
  #SET(%OldLocH,%AtLocH)
 #OF('DETAIL')
  #IF(%OldUse)
%[23]OldUse EQUATE(%OldLocH) #<! %[15]OldType %OldControl
  #ENDIF
  #SET(%AtLabel,'BAND:' & %AtLabel)
  #IF(%AllHeights)
!
! %[23]AtLabel %[15]ReportControlType %ReportControl
!
  #ENDIF
#!%[23]AtLabel EQUATE(%AtLocH) #<! %[15]ReportControlType %ReportControl
  #SET(%OldType,%ReportControlType)
  #SET(%OldControl,%ReportControl)
  #SET(%OldUse,%AtLabel)
  #SET(%OldLocX,%AtLocX)
  #SET(%OldLocY,%AtLocY)
  #SET(%OldLocW,%AtLocW)
  #SET(%OldLocH,%AtLocH)
 #OF('FOOTER')
  #IF(%OldUse)
%[23]OldUse EQUATE(%OldLocH) #<! %[15]OldType %OldControl
  #ENDIF
  #SET(%FooterX,%AtLocX)
  #SET(%FooterH,%AtLocH)
  #SET(%AtLabel,'BAND:' & %AtLabel)
  #IF(%AllHeights)
!
! %[23]AtLabel %[15]ReportControlType %ReportControl
!
  #ENDIF
#!%[23]AtLabel EQUATE(%AtLocH) #<! %[15]ReportControlType %ReportControl
  #SET(%HeadAndFoot,%HeadAndFoot+%FooterH)
  #SET(%OldType,%ReportControlType)
  #SET(%OldControl,%ReportControl)
  #SET(%OldUse,%AtLabel)
  #SET(%OldLocX,%AtLocX)
  #SET(%OldLocY,%AtLocY)
  #SET(%OldLocW,%AtLocW)
  #SET(%OldLocH,%AtLocH)
 #OF('FORM')
  #IF(%OldUse)
%[23]OldUse EQUATE(%OldLocH) #<! %[15]OldType %OldControl
  #ENDIF
  #SET(%FormX,%AtLocX)
  #SET(%FormH,%AtLocH)
  #SET(%AtLabel,'BAND:' & %AtLabel)
  #IF(%AllHeights)
!
! %[23]AtLabel %[15]ReportControlType %ReportControl
!
  #ENDIF
#!%[23]AtLabel EQUATE(%AtLocH) #<! %[15]ReportControlType %ReportControl
  #SET(%OldType,%ReportControlType)
  #SET(%OldControl,%ReportControl)
  #SET(%OldUse,%AtLabel)
  #SET(%OldLocX,%AtLocX)
  #SET(%OldLocY,%AtLocY)
  #SET(%OldLocW,%AtLocW)
  #SET(%OldLocH,%AtLocH)
 #ELSE
  #IF(%AllHeights)
   #SET(%LengthError,'')
   #IF(%AtLocH=0)
    #SET(%AtLocH,0)
   #ENDIF
   #IF((%AtLocY+%AtLocH)>%OldLocH)
    #SET(%LengthError,'*** ERROR: CNTL('& %AtLocY &'+'& %AtLocH &') > BAND('& %OldLocH &') ***')
   #ENDIF
   #SET(%AtLabel,'CNTL:' & %AtLabel)
   #IF(%LengthError)
%[23]AtLabel EQUATE(%AtLocH) #<! %LengthError
   #ELSE
%[23]AtLabel EQUATE(%AtLocH) #<! %[15]ReportControlType %ReportControl
   #ENDIF
  #ENDIF
  #IF((%AtLocY+%AtLocH)>%OldLocH)
   #SET(%OldLocH,(%AtLocY+%AtLocH))
  #ENDIF
 #ENDCASE
#ENDFOR
#!
#IF(%OldUse)
%[23]OldUse EQUATE(%OldLocH) #<! %[15]OldType %OldControl
#ENDIF
!
#SET(%AtLabel,'RPRT:Area')
%[23]AtLabel EQUATE(%rptArea) #<! Total Print Area
#SET(%AtLabel,'RPRT:Width')
%[23]AtLabel EQUATE(%rptWidth) #<! Total Report Width
#SET(%AtLabel,'RPRT:Height')
%[23]AtLabel EQUATE(%rptHeight) #<! Total Report Height
#IF(%FormH)
#SET(%AtLabel,'RPRT:Form')
%[23]AtLabel EQUATE(%FormH) #<! Total Form Height
!EOE: DataSection(LAST)
#ENDIF
#ENDAT
#!--------------------------------------------------------------------
